#include <stdio.h>
#include <stdlib.h>
#include <libmc.h>

int main(int argc, char *argv[]) 
{
  MCAgency_t agency;
  MCAgent_t agent;
  MCAgencyOptions_t options;
  int port=5050;
  int remote_port = 5051;
  char address[100];

  MC_InitializeAgencyOptions(&options);
  MC_SetThreadOff(&options, MC_THREAD_CP); /* Turn off command prompt */
  agency = MC_Initialize(port, &options);
  sprintf(address, "127.0.0.1:%d", 5051);

  agent = MC_ComposeAgent(
    "TestAgent",
    address,
    "localhost",
    "int main(void){\nprintf(\"hello world\\n\");\nreturn 0;\n}",
    NULL,
    address,
		NULL,
    0);
  MC_AddAgent(agency,agent);
  sleep(10);

  agent = MC_ComposeAgentFromFile(
    "MobileAgent1",
    address,
    "localhost",
    "agent.c",
    NULL,
    address,
		NULL,
    0);
  MC_AddAgent(agency,agent);

  sleep(10);

  /* Note: The third argument of the following function may also be a
     valid IP address in the form of a string. i.e. 192.168.0.1 */
  MC_SendAgentMigrationMessageFile(agency,
      "agent.xml",
      "localhost",
      remote_port);


  MC_MainLoop(agency);
  MC_End(agency);
  exit(0);
}
